/******************************************************************************\
 * File: queue.h                                                              *
 * Author: James Greensky                                                     *
 * Notes: define queue routines                                               *
\******************************************************************************/

#ifndef queue_h
#define queue_h

struct QueueRecord;
typedef struct QueueRecord* Queue;

Queue QueueCreate();
void QueueDispose(Queue queue);
int QueueSize(Queue queue);
int QueueEnqueue(Queue queue, void* item);
void* QueueDequeue(Queue queue);
void* QueuePeek(Queue queue);
void QueueRemove(Queue queue, void* item);

#endif
